#!/bin/sh

normal='[0m'
bold='[1m'
italic='[3m'
underline='[4m'
boldOff='[22m'
italicOff='[23m'
underlineOff='[24m'
fgBlack='[30m'
fgRed='[31m'
fgGreen='[32m'
fgYellow='[33m'
fgBlue='[34m'
fgMagenta='[35m'
fgCyan='[36m'
fgWhite='[37m'
fgDefault='[39m'
bgBlack='[40m'
bgRed='[41m'
bgGreen='[42m'
bgYellow='[43m'
bgBlue='[44m'
bgMagenta='[45m'
bgCyan='[46m'
bgWhite='[47m'
bgDefault='[49m'

echo "${bold}${fgRed}News:${normal} " # Puts the word "News" at the top for a header to the module
   
sid=`curl --silent https://www.google.com/accounts/ClientLogin \
	-d Email=USERNAME_WITHOUT_THE_@GMAIL.COM \
	-d Passwd=PASSWORD \
	-d source=Google-cURL-Example \
	-d service=reader \
	| grep -e '^SID='`

tok=`curl -s -X GET http://www.google.com/reader/api/0/token --header "Cookie:$sid"`

data=`curl -s -X GET http://www.google.com/reader/atom/user/-/state/com.google/reading-list --header "Cookie:$sid; $tok"`

echo "$data" | \
#join all into one single line
tr '\n' ' ' | \
#split on <entry> tag 
sed -E 's/(\<\/entry>)/\1\
/g' \
#the next command joins everything in between '<entry>' and '</entry>' tags in 1 single line!
|sed -n -E '	
/\<entry / {
        # put the non-matching line in the hold buffer
        x
        '/label\=\"read\"/' !{
                p
        }
        x
        h
}
/\<entry / !{
        # found a line that matches
        # append it to the hold buffer
        H
}'  \
#splits on every HTML tag
| tr '>' '\n' | \
# selects only lines with "</title" in them
grep "</title"  | \
# removes lines that match "reading list in Google Reader"
grep -v "reading list in Google Reader"  | \
# removes the "</title" string
sed  's/\<\/title//g'  | \
#removes everything that might come before a '|' character. Ex: if the feed source is "Releaselog | RLSLOG.net  Movies" then we return only the "RLSLOG.net  Movies" part
sed -E 's/.+\|[ ]//g' | \
# join every pair of lines into 1
sed '$!N;s/\n/ | /' | \
# the 2 commands below just add some color formatting
sed -E 's/(.+)\|/'"$bold"' \* \1'"${normal}"'\|/' | \
sed -E 's/\|(.+)/'"${fgYellow}"'\|\1'"$normal"'/1' 

